=== contrib/p910nd-0.4/Makefile ===
p910nd:	p910nd.c
	$(CC) -Wall -o $@ p910nd.c
